﻿//using System;

//namespace TestPooling.Pool {
//  using System.Collections.Concurrent;
//  using System.Threading.Tasks;

//  public class ManagedPoolProvider<T> where T : class {
//    private static readonly volatile ConcurrentStack<T[]> partitions = new ConcurrentStack<T[]>();
//    private readonly Func<T> Factory;
//    public readonly int PartitionSize;

//    public ManagedPoolProvider(int partitionSize, Func<T> factory) {
//      PartitionSize = partitionSize;
//      Factory = factory;
//    }

//    public T[] GetPartition() {
//      T[] partition;

//      return partitions.TryPop(out partition) ? partition : CreatePartition();
//    }

//    public void ReleasePartitions(params T[][] partition) {
//      partitions.PushRange(partition);
//    }

//    public T CreateEntry() {
//      return Factory();
//    }

//    private T[] CreatePartition() {
//      //return new T[PartitionSize];

//      var partition = new T[PartitionSize];

//      Parallel.For(0, PartitionSize, i => partition[i] = Factory());

//      return partition;
//    }

//    public ManagedPool<T> CreatePool() {
//      return new ManagedPool<T>(this);
//    }
//  }
//}
